using UnityEngine;
using System.Collections;

public class BoxWalker : MonoBehaviour {

    private float facingAngle = 0f;
    public float turnSpeed = 90f;
    public float moveSpeed = 5f;
    public float gravity = 20f;

    private bool isMoving = false;

    CharacterController controller;

    public bool IsMoving
    {
        get { return isMoving; }
        private set { isMoving = value; }
    }

	// Use this for initialization
	void Start () {
        transform.rotation = Quaternion.AngleAxis(facingAngle, Vector3.up);
        controller = GetComponent<CharacterController>();
	}
	
	// Update is called once per frame
	void Update () {
        float turnAxis = Input.GetAxis("Horizontal");

        bool turnMove = false;
        bool forwardMove = false;

        if (Mathf.Abs(turnAxis) > 0.1f)
        {
            transform.Rotate(Vector3.up, turnAxis * turnSpeed * Time.deltaTime);
            turnMove = true;
        }

        float moveAxis = Input.GetAxis("Vertical");
        Vector3 movement = Vector3.zero;
        if (Mathf.Abs(moveAxis) > 0.1f)
        {
            movement += transform.forward * moveAxis * moveSpeed * Time.deltaTime;
            forwardMove = true;
        }

	    movement.y -= gravity * Time.deltaTime;

        controller.Move(movement);

        IsMoving = turnMove || forwardMove;
	}
}
