using UnityEngine;
using System.Collections;

public class FinalSceneHandler : MonoBehaviour
{
    public Texture2D ShowThisThing;
    public Texture2D BlackTextureUseForFading;

    private bool levelFadedIn = false;
    private bool fadeNow = false;
    private float alphaFadeValue = 0f;

    // Update is called once per frame
    void OnGUI()
    {
        if (GUI.Button(new Rect(-5, -5, Screen.width + 10, Screen.height + 10), ShowThisThing) || Input.anyKeyDown)
            fadeNow = true;
        if (fadeNow)
        {
            alphaFadeValue += Mathf.Clamp01(Time.deltaTime / 5);

            GUI.color = new Color(1f, 1f, 1f, alphaFadeValue);
            GUI.DrawTexture(new Rect(0, 0, Screen.width, Screen.height), BlackTextureUseForFading);

            if (alphaFadeValue > 0.9f)
            {
                Application.LoadLevel(0);
            }
        }
        if (!levelFadedIn)
        {
            alphaFadeValue -= Mathf.Clamp01(Time.deltaTime / 5);

            GUI.color = new Color(1f, 1f, 1f, alphaFadeValue);
            GUI.DrawTexture(new Rect(0, 0, Screen.width, Screen.height), BlackTextureUseForFading);
            if (alphaFadeValue < 0.1f)
            {
                levelFadedIn = true;
            }
        }
    }
}
