using UnityEngine;
using System.Collections;

public class GameWonUi : MonoBehaviour
{
    public GamestateHandler gamestateHandler;
    public Texture2D ShownWhenGameIsWon;

    //public float Top = 200;
    //public float Left = 280;
    //public float Width = 200;

    //public float MenuItemHeight = 26;
    //public float SpaceBetweenTopBorderAndFirstItem = 26;
    //public float SpaceBetweenMenuItems = 5;
    //public float LeftAndRightMarginForMenuItems = 5;
    //public float SpaceBetweenLastMenuItemAndBottom = 5;
    //private Rect MenuPosition;


    //public string[] MenuItemNames;
    //public MenuFunction[] MenuItemFunctions;
    public enum MenuFunction
    {
        NewGame
    }

	public AudioClip winGameSound;
	private bool hasPlayedWingameSound = false;

    public void Start()
    {
        if (ShownWhenGameIsWon == null)
        {
            Debug.LogError("Game Win UI's Shown When Game Is Won texture is not set. Please fix this.");
            Debug.Break();
        }
        //if (MenuItemNames.Length != MenuItemFunctions.Length)
        //    Debug.LogError("Menu Item Names and Menu Item Functions must have the same number of items!");
        //else if (MenuItemNames.Length == 0)
        //{
        //    MenuItemNames = new string[1];
        //    MenuItemNames[0] = "New Game";
        //    MenuItemFunctions = new MenuFunction[1];
        //    MenuItemFunctions[0] = MenuFunction.NewGame;
        //}
    }

    private bool firstTime = true;
    private void FirstTime()
    {
        gamestateHandler = Camera.main.GetComponent<GamestateHandler>();
    }
    void Update()
    {
        if (firstTime)
        {
            FirstTime();
            firstTime = false;
        }

		if (gamestateHandler.Gamestate() == GamestateHandler.GamestateEnum.PlayerWon && 
			!hasPlayedWingameSound)
		{
			hasPlayedWingameSound = true;
			PlayWinGameSound();
		}
		else
		{
			StopSound();
		}
		if (gamestateHandler.Gamestate() == GamestateHandler.GamestateEnum.JustStarted)
		{
			hasPlayedWingameSound = false;
		}
    }

    public void OnGUI()
    {
        if (gamestateHandler.Gamestate() == GamestateHandler.GamestateEnum.PlayerWon)
        {
            //MenuPosition = new Rect(Left, Top, Width, MenuItemNames.Length * MenuItemHeight + MenuItemNames.Length * SpaceBetweenMenuItems - SpaceBetweenMenuItems + SpaceBetweenTopBorderAndFirstItem + SpaceBetweenLastMenuItemAndBottom);
            //GUI.Box(MenuPosition, "YUO AM WIENORZ!");

            //float firstMenuItemTop = Top + SpaceBetweenTopBorderAndFirstItem;
            //for (int i = 0; i < MenuItemNames.Length; i++)
            //{
            //    if (GUI.Button(new Rect(
            //            Left + LeftAndRightMarginForMenuItems,
            //            firstMenuItemTop + i * MenuItemHeight + i * SpaceBetweenMenuItems,
            //            Width - 2 * LeftAndRightMarginForMenuItems, MenuItemHeight),
            //            MenuItemNames[i]))
            //        MenuItemActivated(MenuItemFunctions[i]);
            //}
            if (GUI.Button(new Rect(-5, -5, Screen.width + 10, Screen.height + 10), ShownWhenGameIsWon) || Input.anyKeyDown)
                MenuItemActivated(MenuFunction.NewGame);
        }
    }

    private void MenuItemActivated(MenuFunction activatedItem)
    {
        switch (activatedItem)
        {
            case MenuFunction.NewGame:
                gamestateHandler.ProceedToNextLevel();
                break;
            default:
                break;
        }
    }

	private void PlayWinGameSound()
	{
		if (!this.audio.isPlaying)
		{
			PlaySound(winGameSound, false);
		}
	}

	private void PlaySound(AudioClip soundclip, bool looping)
	{
		if (soundclip != null)
		{
			this.audio.clip = soundclip;
			this.audio.loop = looping;
			this.audio.Play();
		}
	}
	private void StopSound()
	{
		if(this.audio.isPlaying)
		{
			this.audio.Stop();
		}
	}
}
