using UnityEngine;
using System.Collections;

public class MakeSoundWhenMoving : MonoBehaviour {

	public float footstepSoundDelay;
	
	private BoxWalker walker;
	private float lastUpdateTime;

	// Use this for initialization
	void Start () {
		lastUpdateTime = Time.realtimeSinceStartup;
		walker = GetComponent<BoxWalker>();
	}
	
	// Update is called once per frame
	void Update () {
		if (walker != null && 
			walker.IsMoving && 
			Time.realtimeSinceStartup > footstepSoundDelay + lastUpdateTime)
		{
			lastUpdateTime = Time.realtimeSinceStartup;
			this.audio.Play();
		}
	}
}
