using UnityEngine;
using System.Collections;

public class MonkeyAnimations : MonoBehaviour {

    BoxWalker walkScript;
    GamestateHandler stateHandler;

    public Transform leftHand;
    public Transform rightHand;
    public Transform theTV;

    Transform[] tvChildren;

	// Use this for initialization
	void Start () {
        Object[] obj = FindSceneObjectsOfType(typeof(BoxWalker));
        if (obj.Length > 0)
            walkScript = (BoxWalker)obj[0];

        obj = FindSceneObjectsOfType(typeof(GamestateHandler));
        if (obj.Length > 0)
            stateHandler = (GamestateHandler)obj[0];

        tvChildren = new Transform[theTV.childCount];
        for (int i = 0; i < theTV.childCount; i++)
        {
            tvChildren[i] = theTV.GetChild(i);
     
        }

        RelocateTV(theTV, rightHand);
        animation.Play("walk");
	}

    private void RelocateTV(Transform oldParent, Transform newParent)
    {
        oldParent.DetachChildren();
        for (int i = 0; i < tvChildren.Length; i++)
        {
            tvChildren[i].parent = newParent;
        }
    }

    private bool isDead = false;
    private bool isPlayingFacepalm = false;
	
	// Update is called once per frame
	void Update () {

        if (!isDead && stateHandler.Gamestate() == GamestateHandler.GamestateEnum.PlayerSpotted)
        {
            isDead = true;
            RelocateTV(rightHand, leftHand);
        }

        if (isDead)
        {
            if (!isPlayingFacepalm)
            {
                animation.CrossFade("facepalm");
                isPlayingFacepalm = true;
            }
        }
        else
        {
            if (walkScript.IsMoving)
                animation.CrossFade("walk");
            else
                animation.CrossFade("idle");
        }
	}
}
