using UnityEngine;
using System.Collections;

public class SoundAlarmOnSpotting : MonoBehaviour
{
	public GamestateHandler gameState;
	private CameraDetector detector;

	// Use this for initialization
	void Start () {
		detector = GetComponent<CameraDetector>();
	}
	
	// Update is called once per frame
	void Update () {
		if (gameState != null && gameState.Gamestate() == GamestateHandler.GamestateEnum.JustStarted)
		{
			this.audio.Stop();
			return;
		}
		if (
			detector != null
			&& !this.audio.isPlaying 
			&& detector.dangerLevel >= detector.alarmDangerLevel
		)
		{
			this.audio.Play();
		}
	}
}
